# Presentation slides

This repository contains all presentations related to R3.

## Prerequisites

In order to use the slide deck, you must have:

- **git**: For convenience, have your SSH key configured on git-r3lab. [Here](https://docs.gitlab.com/ee/gitlab-basics/create-your-ssh-keys.html) is how to do it.
- **git-lfs**: Installation instructions are [here](https://help.github.com/en/articles/installing-git-large-file-storage)
- **Python 3**: It is recommend to use a virtual environment
- **yarn**: Instructions are [here](https://yarnpkg.com/lang/en/docs/install)

## How to get started

- Fork this repository
- Clone your fork
    ```bash
    $ git clone --recurse-submodules ssh://git@git-r3lab-server.uni.lu:8022/<yourUsername>/presentations.git
    ```
- Open a terminal and work on your presentation:
    ```bash
    $ cd presentations
    $ pip install .
    $ contribute --date="YYYY-MM-DD" --name="yourAwesomeTitle"
    ```

<img src="https://webdav-r3lab.uni.lu/public/R3lab/logos/warning.png" height="20px" width="20px"> Please create a branch from `develop` before starting to work on your presentation. You could name it `YYYY-MM-DD_yourAwesomeTitle`.

If you are done with making changes to your presentation, push them to your fork and open a merge request against the `develop` branch.

## How to continue
 For resuming your work on a presentation, you can either run the same contribute command:</br>
 ```
 $ contribute --date="YYYY-MM-DD" --name="yourAwesomeTitle"
 ```

 or you can navigate to your presentation directory and start `grunt` server:
 ```
 $ cd YYYY/yourAwesomeTitle/
 $ grunt server
 ```

## Adding a new slide/slides
 Create a Markdown file with your slide(s) in `YYYY-MM-DD_yourAwesomeTitle/slides` and place it into `list.md` file at desired position:

```
 [
    {"filename": "index.md","attr": {}},
    {"filename": "structure.md","attr": {}},
    {"filename": "myNewAwesomeSlide.md","attr": {}},
    {"filename": "thanks.md","attr": {}}
]
```
